VTK: vtkTemporalInterpolatedVelocityField Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
vtkTemporalInterpolatedVelocityField Class Reference

A helper class for interpolating between times during particle tracing. More...

`#include <vtkTemporalInterpolatedVelocityField.h>`

Inheritance diagram for vtkTemporalInterpolatedVelocityField:
[legend]
Collaboration diagram for vtkTemporalInterpolatedVelocityField:
[legend]

## Public Types
enum | IDStates { INSIDE_ALL = 0 , OUTSIDE_ALL = 1 , OUTSIDE_T0 = 2 , OUTSIDE_T1 = 3 }
| States that define where the cell id are. More...
enum | MeshOverTimeTypes { DIFFERENT = 0 , STATIC = 1 , LINEAR_TRANSFORMATION = 2 , SAME_TOPOLOGY = 3 }
| Types of Variance of Mesh over time. More...
typedef vtkFunctionSet | Superclass
Public Types inherited from vtkFunctionSet
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkTemporalInterpolatedVelocityField * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Initialize (vtkCompositeDataSet *t0, vtkCompositeDataSet *t1)
| The Initialize() method is used to build and cache supporting structures (such as locators) which are used when operating on the interpolated velocity field. More...
virtual void | CopyParameters (vtkTemporalInterpolatedVelocityField *from)
| Copy essential parameters between instances of this class. More...
void | SelectVectors (const char *fieldName)
| If you want to work with an arbitrary vector array, then set its name here. More...
void | ClearCache ()
| Set the last cell id to -1 so that the next search does not start from the previous cell. More...
bool | InterpolatePoint (vtkPointData *outPD1, vtkPointData *outPD2, vtkIdType outIndex)
bool | InterpolatePoint (int T, vtkPointData *outPD1, vtkIdType outIndex)
bool | GetVorticityData (int T, double pcoords[3], double *weights, vtkGenericCell *&cell, vtkDoubleArray *cellVectors)
void | ShowCacheResults ()
bool | IsStatic (int)
void | AdvanceOneTimeStep ()
virtual void | SetMeshOverTime (int)
void | SetMeshOverTimeToDifferent ()
void | SetMeshOverTimeToStatic ()
void | SetMeshOverTimeToLinearTransformation ()
void | SetMeshOverTimeToSameTopology ()
virtual int | GetMeshOverTime ()
int | FunctionValues (double *x, double *u) override
| Evaluate the velocity field, f, at (x, y, z, t). More...
int | FunctionValuesAtT (int T, double *x, double *u)
| Evaluate the velocity field, f, at (x, y, z, t). More...
void | AddDataSetAtTime (int N, double T, vtkDataSet *dataset)
| In order to use this class, two sets of data must be supplied, corresponding to times T1 and T2. More...
void | SetDataSetAtTime (int, int, double, vtkDataSet *, bool)
| In order to use this class, two sets of data must be supplied, corresponding to times T1 and T2. More...
bool | GetCachedCellIds (vtkIdType id[2], int ds[2])
| Between iterations of the Particle Tracer, Id's of the Cell are stored and then at the start of the next particle the Ids are set to 'pre-fill' the cache. More...
void | SetCachedCellIds (vtkIdType id[2], int ds[2])
| Between iterations of the Particle Tracer, Id's of the Cell are stored and then at the start of the next particle the Ids are set to 'pre-fill' the cache. More...
int | TestPoint (double *x)
| A utility function which evaluates the point at T1, T2 to see if it is inside the data at both times or only one. More...
int | QuickTestPoint (double *x)
| A utility function which evaluates the point at T1, T2 to see if it is inside the data at both times or only one. More...
virtual double * | GetLastGoodVelocity ()
| If an interpolation was successful, we can retrieve the last computed value from here. More...
virtual void | GetLastGoodVelocity (double &, double &, double &)
| If an interpolation was successful, we can retrieve the last computed value from here. More...
virtual void | GetLastGoodVelocity (double[3])
| If an interpolation was successful, we can retrieve the last computed value from here. More...
virtual double | GetCurrentWeight ()
| Get the most recent weight between 0->1 from T1->T2. More...
virtual void | SetFindCellStrategy (vtkFindCellStrategy *)
| Set / get the strategy used to perform the FindCell() operation. More...
virtual vtkFindCellStrategy * | GetFindCellStrategy ()
| Set / get the strategy used to perform the FindCell() operation. More...
Public Member Functions inherited from vtkFunctionSet
vtkFunctionSet * | NewInstance () const
virtual int | FunctionValues (double *x, double *f, void *vtkNotUsed(userData))
virtual int | GetNumberOfFunctions ()
| Return the number of functions. More...
virtual int | GetNumberOfIndependentVariables ()
| Return the number of independent variables. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkTemporalInterpolatedVelocityField * | SafeDownCast (vtkObjectBase *o)
static vtkTemporalInterpolatedVelocityField * | New ()
| Construct a vtkTemporalInterpolatedVelocityField with no initial data set. More...
Static Public Member Functions inherited from vtkFunctionSet
static vtkTypeBool | IsTypeOf (const char *type)
static vtkFunctionSet * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkTemporalInterpolatedVelocityField ()
| ~vtkTemporalInterpolatedVelocityField () override
virtual void | SetVectorsSelection (const char *v)
void | InitializeWithLocators (vtkCompositeInterpolatedVelocityField *ivf, const std::vector< vtkDataSet * > &datasets, vtkFindCellStrategy *strategy, const std::vector< vtkSmartPointer< vtkLocator >> &locators, const std::vector< vtkSmartPointer< vtkAbstractCellLinks >> &links)
void | CreateLocators (const std::vector< vtkDataSet * > &datasets, vtkFindCellStrategy *strategy, std::vector< vtkSmartPointer< vtkLocator >> &locators)
void | CreateLinks (const std::vector< vtkDataSet * > &datasets, std::vector< vtkSmartPointer< vtkAbstractCellLinks >> &links)
void | CreateLinearTransformCellLocators (const std::vector< vtkSmartPointer< vtkLocator >> &locators, std::vector< vtkSmartPointer< vtkLocator >> &linearCellLocators)
Protected Member Functions inherited from vtkFunctionSet
| vtkFunctionSet ()
| ~vtkFunctionSet () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | MeshOverTime = MeshOverTimeTypes::DIFFERENT
double | Vals1 [3]
double | Vals2 [3]
double | Times [2]
double | LastGoodVelocity [3]
double | CurrentWeight
double | OneMinusWeight
double | ScaleCoeff
vtkSmartPointer< vtkCompositeInterpolatedVelocityField > | IVF [2]
std::vector< vtkSmartPointer< vtkLocator > > | Locators [2]
std::vector< vtkSmartPointer< vtkLocator > > | InitialCellLocators
std::vector< vtkSmartPointer< vtkAbstractCellLinks > > | Links [2]
std::vector< size_t > | MaxCellSizes [2]
vtkFindCellStrategy * | FindCellStrategy
Protected Attributes inherited from vtkFunctionSet
int | NumFuncs
int | NumIndepVars
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Static Protected Attributes
static const double | WEIGHT_TO_TOLERANCE

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

A helper class for interpolating between times during particle tracing.

vtkTemporalInterpolatedVelocityField is a general purpose helper for the temporal particle tracing code (vtkParticleTracerBase)

It maintains two copies of vtkCompositeInterpolatedVelocityField internally and uses them to obtain velocity values at time T0 and T1.

In fact the class does quite a bit more than this because when the geometry of the datasets is the same at T0 and T1, we can re-use cached cell Ids and weights used in the cell interpolation routines. Additionally, the same weights can be used when interpolating (point) scalar values and computing vorticity etc.

Warning
  vtkTemporalInterpolatedVelocityField is not thread safe. A new instance should be created by each thread.
  Datasets are added in lists. The list for T1 must be identical to that for T0 in structure/topology and dataset order, and any datasets marked as static, must remain so for all T - changing a dataset from static to dynamic between time steps will result in undefined behaviour (=crash probably)

See also
  vtkCompositeInterpolatedVelocityField vtkParticleTracerBase vtkParticleTracer vtkParticlePathFilter vtkStreaklineFilter

Definition at line 57 of file vtkTemporalInterpolatedVelocityField.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkFunctionSet vtkTemporalInterpolatedVelocityField::Superclass

Definition at line 60 of file vtkTemporalInterpolatedVelocityField.h.

## Member Enumeration Documentation

## ◆ IDStates

enum vtkTemporalInterpolatedVelocityField::IDStates

States that define where the cell id are.

Enumerator
INSIDE_ALL |
OUTSIDE_ALL |
OUTSIDE_T0 |
OUTSIDE_T1 |

Definition at line 72 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ MeshOverTimeTypes

enum vtkTemporalInterpolatedVelocityField::MeshOverTimeTypes

Types of Variance of Mesh over time.

Enumerator
DIFFERENT |
STATIC |
LINEAR_TRANSFORMATION |
SAME_TOPOLOGY |

Definition at line 83 of file vtkTemporalInterpolatedVelocityField.h.

## Constructor & Destructor Documentation

## ◆ vtkTemporalInterpolatedVelocityField()

vtkTemporalInterpolatedVelocityField::vtkTemporalInterpolatedVelocityField | ( |  | ) |
| protected

## ◆ ~vtkTemporalInterpolatedVelocityField()

vtkTemporalInterpolatedVelocityField::~vtkTemporalInterpolatedVelocityField | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkTemporalInterpolatedVelocityField::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkTemporalInterpolatedVelocityField::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkFunctionSet.

## ◆ SafeDownCast()

static vtkTemporalInterpolatedVelocityField* vtkTemporalInterpolatedVelocityField::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkTemporalInterpolatedVelocityField::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkFunctionSet.

## ◆ NewInstance()

vtkTemporalInterpolatedVelocityField* vtkTemporalInterpolatedVelocityField::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkTemporalInterpolatedVelocityField::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkFunctionSet.

## ◆ New()

static vtkTemporalInterpolatedVelocityField* vtkTemporalInterpolatedVelocityField::New | ( |  | ) |
| static

Construct a vtkTemporalInterpolatedVelocityField with no initial data set.

Caching is on. LastCellId is set to -1.

## ◆ SetMeshOverTime()

virtual void vtkTemporalInterpolatedVelocityField::SetMeshOverTime | ( | int |  | ) |
| virtual

## ◆ SetMeshOverTimeToDifferent()

void vtkTemporalInterpolatedVelocityField::SetMeshOverTimeToDifferent | ( |  | ) |
| inline

Definition at line 101 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ SetMeshOverTimeToStatic()

void vtkTemporalInterpolatedVelocityField::SetMeshOverTimeToStatic | ( |  | ) |
| inline

Definition at line 102 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ SetMeshOverTimeToLinearTransformation()

void vtkTemporalInterpolatedVelocityField::SetMeshOverTimeToLinearTransformation | ( |  | ) |
| inline

Definition at line 103 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ SetMeshOverTimeToSameTopology()

void vtkTemporalInterpolatedVelocityField::SetMeshOverTimeToSameTopology | ( |  | ) |
| inline

Definition at line 104 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ GetMeshOverTime()

virtual int vtkTemporalInterpolatedVelocityField::GetMeshOverTime | ( |  | ) |
| virtual

## ◆ Initialize()

void vtkTemporalInterpolatedVelocityField::Initialize | ( | vtkCompositeDataSet * | t0,
|  | vtkCompositeDataSet * | t1
| ) |  |

The Initialize() method is used to build and cache supporting structures (such as locators) which are used when operating on the interpolated velocity field.

This method is needed mainly to deal with thread safety issues; i.e., these supporting structures must be built at the right time to avoid race conditions.

## ◆ CopyParameters()

virtual void vtkTemporalInterpolatedVelocityField::CopyParameters | ( | vtkTemporalInterpolatedVelocityField * | from | ) |
| virtual

Copy essential parameters between instances of this class.

This generally is used to copy from instance prototype to another, or to copy interpolators between thread instances. Sub-classes can contribute to the parameter copying process via chaining.

## ◆ FunctionValues()

int vtkTemporalInterpolatedVelocityField::FunctionValues | ( | double * | x,
|  | double * | u
| ) |  |
| overridevirtual

Evaluate the velocity field, f, at (x, y, z, t).

For now, t is ignored.

Reimplemented from vtkFunctionSet.

## ◆ FunctionValuesAtT()

int vtkTemporalInterpolatedVelocityField::FunctionValuesAtT | ( | int | T,
|  | double * | x,
|  | double * | u
| ) |  |

Evaluate the velocity field, f, at (x, y, z, t).

For now, t is ignored.

## ◆ SelectVectors()

void vtkTemporalInterpolatedVelocityField::SelectVectors | ( | const char * | fieldName | ) |
| inline

If you want to work with an arbitrary vector array, then set its name here.

By default this is nullptr and the filter will use the active vector array.

Definition at line 140 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ AddDataSetAtTime()

void vtkTemporalInterpolatedVelocityField::AddDataSetAtTime | ( | int | N,
|  | double | T,
|  | vtkDataSet * | dataset
| ) |  |

In order to use this class, two sets of data must be supplied, corresponding to times T1 and T2.

Data is added via this function.

## ◆ SetDataSetAtTime()

void vtkTemporalInterpolatedVelocityField::SetDataSetAtTime | ( | int | ,
|  | int | ,
|  | double | ,
|  | vtkDataSet * | ,
|  | bool |
| ) |  |
| inline

In order to use this class, two sets of data must be supplied, corresponding to times T1 and T2.

Data is added via this function.

Definition at line 150 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ GetCachedCellIds()

bool vtkTemporalInterpolatedVelocityField::GetCachedCellIds | ( | vtkIdType | id[2],
|  | int | ds[2]
| ) |  |

Between iterations of the Particle Tracer, Id's of the Cell are stored and then at the start of the next particle the Ids are set to 'pre-fill' the cache.

## ◆ SetCachedCellIds()

void vtkTemporalInterpolatedVelocityField::SetCachedCellIds | ( | vtkIdType | id[2],
|  | int | ds[2]
| ) |  |

Between iterations of the Particle Tracer, Id's of the Cell are stored and then at the start of the next particle the Ids are set to 'pre-fill' the cache.

## ◆ ClearCache()

void vtkTemporalInterpolatedVelocityField::ClearCache | ( |  | ) |

Set the last cell id to -1 so that the next search does not start from the previous cell.

## ◆ TestPoint()

int vtkTemporalInterpolatedVelocityField::TestPoint | ( | double * | x | ) |

A utility function which evaluates the point at T1, T2 to see if it is inside the data at both times or only one.

## ◆ QuickTestPoint()

int vtkTemporalInterpolatedVelocityField::QuickTestPoint | ( | double * | x | ) |

A utility function which evaluates the point at T1, T2 to see if it is inside the data at both times or only one.

## ◆ GetLastGoodVelocity() [1/3]

virtual double* vtkTemporalInterpolatedVelocityField::GetLastGoodVelocity | ( |  | ) |
| virtual

If an interpolation was successful, we can retrieve the last computed value from here.

Initial value is (0.0,0.0,0.0)

## ◆ GetLastGoodVelocity() [2/3]

virtual void vtkTemporalInterpolatedVelocityField::GetLastGoodVelocity | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

If an interpolation was successful, we can retrieve the last computed value from here.

Initial value is (0.0,0.0,0.0)

## ◆ GetLastGoodVelocity() [3/3]

virtual void vtkTemporalInterpolatedVelocityField::GetLastGoodVelocity | ( | double | [3] | ) |
| virtual

If an interpolation was successful, we can retrieve the last computed value from here.

Initial value is (0.0,0.0,0.0)

## ◆ GetCurrentWeight()

virtual double vtkTemporalInterpolatedVelocityField::GetCurrentWeight | ( |  | ) |
| virtual

Get the most recent weight between 0->1 from T1->T2.

Initial value is 0.

## ◆ InterpolatePoint() [1/2]

bool vtkTemporalInterpolatedVelocityField::InterpolatePoint | ( | vtkPointData * | outPD1,
|  | vtkPointData * | outPD2,
|  | vtkIdType | outIndex
| ) |  |

## ◆ InterpolatePoint() [2/2]

bool vtkTemporalInterpolatedVelocityField::InterpolatePoint | ( | int | T,
|  | vtkPointData * | outPD1,
|  | vtkIdType | outIndex
| ) |  |

## ◆ GetVorticityData()

bool vtkTemporalInterpolatedVelocityField::GetVorticityData | ( | int | T,
|  | double | pcoords[3],
|  | double * | weights,
|  | vtkGenericCell *& | cell,
|  | vtkDoubleArray * | cellVectors
| ) |  |

## ◆ ShowCacheResults()

void vtkTemporalInterpolatedVelocityField::ShowCacheResults | ( |  | ) |

## ◆ IsStatic()

bool vtkTemporalInterpolatedVelocityField::IsStatic | ( | int |  | ) |
| inline

Definition at line 202 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ AdvanceOneTimeStep()

void vtkTemporalInterpolatedVelocityField::AdvanceOneTimeStep | ( |  | ) |

## ◆ SetFindCellStrategy()

virtual void vtkTemporalInterpolatedVelocityField::SetFindCellStrategy | ( | vtkFindCellStrategy * |  | ) |
| virtual

Set / get the strategy used to perform the FindCell() operation.

This strategy is used when operating on vtkPointSet subclasses. Note if the input is a composite dataset then the strategy will be used to clone one strategy per leaf dataset.

## ◆ GetFindCellStrategy()

virtual vtkFindCellStrategy* vtkTemporalInterpolatedVelocityField::GetFindCellStrategy | ( |  | ) |
| virtual

Set / get the strategy used to perform the FindCell() operation.

This strategy is used when operating on vtkPointSet subclasses. Note if the input is a composite dataset then the strategy will be used to clone one strategy per leaf dataset.

## ◆ SetVectorsSelection()

virtual void vtkTemporalInterpolatedVelocityField::SetVectorsSelection | ( | const char * | v | ) |
| protectedvirtual

## ◆ InitializeWithLocators()

void vtkTemporalInterpolatedVelocityField::InitializeWithLocators | ( | vtkCompositeInterpolatedVelocityField * | ivf,
|  | const std::vector< vtkDataSet * > & | datasets,
|  | vtkFindCellStrategy * | strategy,
|  | const std::vector< vtkSmartPointer< vtkLocator >> & | locators,
|  | const std::vector< vtkSmartPointer< vtkAbstractCellLinks >> & | links
| ) |  |
| protected

## ◆ CreateLocators()

void vtkTemporalInterpolatedVelocityField::CreateLocators | ( | const std::vector< vtkDataSet * > & | datasets,
|  | vtkFindCellStrategy * | strategy,
|  | std::vector< vtkSmartPointer< vtkLocator >> & | locators
| ) |  |
| protected

## ◆ CreateLinks()

void vtkTemporalInterpolatedVelocityField::CreateLinks | ( | const std::vector< vtkDataSet * > & | datasets,
|  | std::vector< vtkSmartPointer< vtkAbstractCellLinks >> & | links
| ) |  |
| protected

## ◆ CreateLinearTransformCellLocators()

void vtkTemporalInterpolatedVelocityField::CreateLinearTransformCellLocators | ( | const std::vector< vtkSmartPointer< vtkLocator >> & | locators,
|  | std::vector< vtkSmartPointer< vtkLocator >> & | linearCellLocators
| ) |  |
| protected

## Member Data Documentation

## ◆ MeshOverTime

int vtkTemporalInterpolatedVelocityField::MeshOverTime = MeshOverTimeTypes::DIFFERENT
| protected

Definition at line 223 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ Vals1

double vtkTemporalInterpolatedVelocityField::Vals1[3]
| protected

Definition at line 237 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ Vals2

double vtkTemporalInterpolatedVelocityField::Vals2[3]
| protected

Definition at line 238 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ Times

double vtkTemporalInterpolatedVelocityField::Times[2]
| protected

Definition at line 239 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ LastGoodVelocity

double vtkTemporalInterpolatedVelocityField::LastGoodVelocity[3]
| protected

Definition at line 240 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ WEIGHT_TO_TOLERANCE

const double vtkTemporalInterpolatedVelocityField::WEIGHT_TO_TOLERANCE
| staticprotected

Definition at line 242 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ CurrentWeight

double vtkTemporalInterpolatedVelocityField::CurrentWeight
| protected

Definition at line 246 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ OneMinusWeight

double vtkTemporalInterpolatedVelocityField::OneMinusWeight
| protected

Definition at line 248 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ ScaleCoeff

double vtkTemporalInterpolatedVelocityField::ScaleCoeff
| protected

Definition at line 250 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ IVF

vtkSmartPointer<vtkCompositeInterpolatedVelocityField> vtkTemporalInterpolatedVelocityField::IVF[2]
| protected

Definition at line 252 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ Locators

std::vector<vtkSmartPointer<vtkLocator> > vtkTemporalInterpolatedVelocityField::Locators[2]
| protected

Definition at line 253 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ InitialCellLocators

std::vector<vtkSmartPointer<vtkLocator> > vtkTemporalInterpolatedVelocityField::InitialCellLocators
| protected

Definition at line 254 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ Links

std::vector<vtkSmartPointer<vtkAbstractCellLinks> > vtkTemporalInterpolatedVelocityField::Links[2]
| protected

Definition at line 255 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ MaxCellSizes

std::vector<size_t> vtkTemporalInterpolatedVelocityField::MaxCellSizes[2]
| protected

Definition at line 256 of file vtkTemporalInterpolatedVelocityField.h.

## ◆ FindCellStrategy

vtkFindCellStrategy* vtkTemporalInterpolatedVelocityField::FindCellStrategy
| protected

Definition at line 258 of file vtkTemporalInterpolatedVelocityField.h.

The documentation for this class was generated from the following file:

- Filters/FlowPaths/vtkTemporalInterpolatedVelocityField.h